(function() {
  var Promise, _, cache, gGet, gSet, log;

  _ = require('lodash');

  Promise = require('bluebird');

  log = require('../log');

  cache = {};

  exports.cache = cache;

  gGet = function*(keys, alternative) {
    var r, ref;
    r = (yield Promise.resolve((ref = _.get(cache, keys)) != null ? ref : alternative));
    return r;
  };

  gSet = function*(keys, value) {
    return (yield Promise.resolve(_.set(cache, keys, value)));
  };

  exports.gGetString = gGet;

  exports.gSetString = gSet;

  exports.gGetCachedString = gGet;

  exports.gSetCachedString = gSet;

  exports.gGetObject = gGet;

  exports.gSetObject = gSet;

  exports.gUnset = function*(keys, lastKeys) {
    var i, keysLength, lastKey, len;
    if (lastKeys != null ? lastKeys.length : void 0) {
      keys = _.clone(keys);
      keysLength = keys.length;
      for (i = 0, len = lastKeys.length; i < len; i++) {
        lastKey = lastKeys[i];
        keys[keysLength] = lastKey;
        _.unset(cache, keys);
      }
    } else {
      _.unset(cache, keys);
    }
  };

  exports.gClearAllCache = function*() {
    log.system.info("clear all cache / memory");
    cache = {};
    exports.cache = cache;
  };

}).call(this);
