(function() {
  var Error401, Error403, MyError, SystemError, UniqueConflictError, UserError, define, errors,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  errors = {};

  define = function(code, message) {
    return errors[code] = message;
  };

  define('DupKey', '数据重复');

  define('ConcurrentUpdate', '修改冲突');

  define('NoSuchEntity', '操作对象不存在');

  define('CreateNotAllow', '不允许创建');

  define('EditNotAllow', '不允许编辑');

  define('DeleteNotAllow', '不允许删除');

  define('EmptyOperation', '空操作');

  define("BadQueryCriteria", "查询条件Criteria错误");

  define("SubAppNotExisted", "无此应用");

  define("UserNotExisted", "无此用户");

  define("UserDisabled", "被禁用用户");

  define("PasswordNotMatch", "密码错误");

  define('BadPasswordFormat', '密码格式不符合要求');

  define('SecurityCodeNotMatch', '验证码错误');

  define('SecurityCodeExpired', '验证码失效或过期');

  define('CaptchaWrong', '图形验证码错误');

  define('PayTranNotFound', '查无此交易');

  define('PayTranStateChangeIllegal', '支付状态修改非法');

  define('BadAmount', '金额错误');

  MyError = (function(superClass) {
    extend(MyError, superClass);

    function MyError(code1, message) {
      this.code = code1;
      this.message = message || errors[this.code];
      MyError.__super__.constructor.call(this, this.message);
      this.stack = (new Error()).stack;
    }

    MyError.prototype.describe = function() {
      return {
        code: this.code,
        message: this.message
      };
    };

    return MyError;

  })(Error);

  UserError = (function(superClass) {
    extend(UserError, superClass);

    function UserError(code1, message) {
      this.code = code1;
      UserError.__super__.constructor.call(this, this.code, message);
    }

    return UserError;

  })(MyError);

  UniqueConflictError = (function(superClass) {
    extend(UniqueConflictError, superClass);

    function UniqueConflictError(code1, message, key) {
      this.code = code1;
      this.key = key;
      UniqueConflictError.__super__.constructor.call(this, this.code, message);
    }

    return UniqueConflictError;

  })(UserError);

  SystemError = (function(superClass) {
    extend(SystemError, superClass);

    function SystemError(code1, message) {
      this.code = code1;
      SystemError.__super__.constructor.call(this, this.code, message);
    }

    return SystemError;

  })(MyError);

  Error401 = (function(superClass) {
    extend(Error401, superClass);

    function Error401(code1, message) {
      this.code = code1;
      Error401.__super__.constructor.call(this, this.code, message);
    }

    return Error401;

  })(MyError);

  Error403 = (function(superClass) {
    extend(Error403, superClass);

    function Error403() {
      Error403.__super__.constructor.call(this, "", "");
    }

    return Error403;

  })(MyError);

  exports.UserError = UserError;

  exports.UniqueConflictError = UniqueConflictError;

  exports.SystemError = SystemError;

  exports.Error401 = Error401;

  exports.Error403 = Error403;

}).call(this);
