(function() {
  var Promise, fs, log, pMakeDir, pRename, pStat, path;

  fs = require('fs');

  path = require('path');

  Promise = require('bluebird');

  pMakeDir = Promise.promisify(require('mkdirp'));

  exports.pUnlink = Promise.promisify(fs.unlink);

  pRename = Promise.promisify(fs.rename);

  pStat = Promise.promisify(fs.stat);

  log = require('./log');

  exports.gMoveFileTo = function*(oldName, newName) {
    var e, stats, targetDir;
    targetDir = path.dirname(newName);
    try {
      stats = (yield pStat(targetDir));
    } catch (error) {
      e = error;
      log.system.error(e, 'pStat');
    }
    if (!(stats != null ? stats.isDirectory() : void 0)) {
      yield pMakeDir(targetDir);
    }
    return (yield pRename(oldName, newName));
  };

  exports.gFileExists = function*(fileFullPath) {
    var e;
    try {
      yield pStat(fileFullPath);
      return true;
    } catch (error) {
      e = error;
      if (e.code === 'ENOENT') {
        return false;
      }
      throw e;
    }
  };

}).call(this);
