(function() {
  var Cache, chance;

  chance = new require('chance')();

  Cache = require('../cache/Cache');

  exports.gGenerate = function*(next) {
    var captcha, id, simpleCaptcha, text;
    simpleCaptcha = require('simple-captcha');
    captcha = simpleCaptcha.create({
      width: 100,
      height: 40
    });
    text = captcha.text();
    captcha.generate();
    id = chance.hash();
    this.cookies.set('captcha_id', id, {
      signed: true,
      httpOnly: true
    });
    yield* Cache.gSetString(['captcha', id], text);
    this.set('X-Captcha-Id', id);
    this.body = captcha.buffer('image/png');
    return this.type = 'image/png';
  };

  exports.gCheck = function*(id, text) {
    var expected;
    if (!((id != null) && (text != null))) {
      return false;
    }
    expected = (yield* Cache.gGetString(['captcha', id]));
    return expected === text;
  };

  exports.gClearById = function*(id) {
    return (yield* Cache.gUnset(['captcha'], [id]));
  };

}).call(this);
