(function() {
  var _, defaultInterceptor, interceptors,
    slice = [].slice;

  _ = require('lodash');

  exports.Actions = {
    Create: 'Create',
    Update: 'Update',
    Remove: "Remove",
    Get: 'Get',
    List: "List"
  };

  defaultInterceptor = function*() {
    var args;
    args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    return (yield* args[args.length - 1]());
  };

  interceptors = {};

  exports.setInterceptor = function(entityName, actions, gInterceptor) {
    var action, i, len, ref, results;
    if (!_.isArray(actions)) {
      actions = [actions];
    }
    interceptors[entityName] = (ref = interceptors[entityName]) != null ? ref : {};
    results = [];
    for (i = 0, len = actions.length; i < len; i++) {
      action = actions[i];
      results.push(interceptors[entityName][action] = gInterceptor);
    }
    return results;
  };

  exports.getInterceptor = function(entityName, action) {
    var ref;
    return ((ref = interceptors[entityName]) != null ? ref[action] : void 0) || defaultInterceptor;
  };

}).call(this);
