(function() {
  var Meta, SystemMeta;

  Meta = require('../Meta');

  SystemMeta = require('../SystemMeta');

  exports.gGetAllMeta = function*() {
    this.body = Meta.getMetaForFront();
  };

  exports.gGetMeta = function*() {
    var name, type;
    type = this.params.type;
    name = this.params.name;
    if (type === 'entity') {
      this.body = Meta.getEntities()[name];
    } else if (type === 'view') {
      this.body = Meta.getViews()[name];
    } else {
      this.status = 400;
    }
  };

  exports.gSaveMeta = function*() {
    var meta, name, type;
    type = this.params.type;
    name = this.params.name;
    meta = this.request.body;
    if (type === 'entity') {
      yield* Meta.gSaveEntityMeta(name, meta);
    } else if (type === 'view') {
      yield* Meta.gSaveViewMeta(name, meta);
    } else {
      return this.status = 400;
    }
    return this.status = 204;
  };

  exports.gImportMeta = function*() {
    var e, i, j, len, len1, meta, ref, ref1, v;
    meta = this.request.body;
    ref = meta.entities;
    for (i = 0, len = ref.length; i < len; i++) {
      e = ref[i];
      delete e._id;
      yield* Meta.gSaveEntityMeta(e.name, e);
    }
    ref1 = meta.views;
    for (j = 0, len1 = ref1.length; j < len1; j++) {
      v = ref1[j];
      delete v._id;
      yield* Meta.gSaveViewMeta(v.name, v);
    }
    return this.status = 204;
  };

  exports.gRemoveMeta = function*() {
    var name, type;
    type = this.params.type;
    name = this.params.name;
    if (type === 'entity') {
      yield* Meta.gRemoveEntityMeta(name);
    } else if (type === 'view') {
      yield* Meta.gRemoveViewMeta(name);
    } else {
      return this.status = 400;
    }
    return this.status = 204;
  };

  exports.gGetEmptyEntityMeta = function*() {
    var e;
    e = {
      fields: {},
      db: Meta.DB.mongo
    };
    SystemMeta.patchSystemFields(e);
    this.body = e;
  };

  exports.gGetActions = function*() {
    this.body = Meta.actions;
  };

}).call(this);
