(function() {
  var CaptchaHandler, SecurityCodeService, config, error;

  CaptchaHandler = require('./CaptchaHandler');

  error = require('../error');

  config = require('../config');

  SecurityCodeService = require('../security/SecurityCodeService');

  exports.gSendSignUpCodeToPhone = function*() {
    var captchaId, captchaText, phone, ref, ref1;
    captchaId = ((ref = this.request.body) != null ? ref.captchaId : void 0) || this.cookies.get('captcha_id', {
      signed: true
    });
    captchaText = (ref1 = this.request.body) != null ? ref1.captchaText : void 0;
    if (!(captchaId && captchaText)) {
      throw new error.UserError('CaptchaWrong');
    }
    if (!(yield* CaptchaHandler.gCheck(captchaId, captchaText))) {
      yield* CaptchaHandler.gClearById(captchaId);
      throw new error.UserError('CaptchaWrong');
    }
    yield* CaptchaHandler.gClearById(captchaId);
    phone = this.params.phone;
    if (!phone) {
      return this.status = 400;
    }
    yield* SecurityCodeService.gSendSecurityCodeToPhone(phone, config.signUpMessage);
    return this.status = 204;
  };

  exports.gSendSignUpCodeToEmail = function*() {
    var captchaId, captchaText, email, message, ref, ref1;
    captchaId = ((ref = this.request.body) != null ? ref.captchaId : void 0) || this.cookies.get('captcha_id', {
      signed: true
    });
    captchaText = (ref1 = this.request.body) != null ? ref1.captchaText : void 0;
    if (!(captchaId && captchaText)) {
      throw new error.UserError('CaptchaWrong');
    }
    if (!(yield* CaptchaHandler.gCheck(captchaId, captchaText))) {
      yield* CaptchaHandler.gClearById(captchaId);
      throw new error.UserError('CaptchaWrong');
    }
    yield* CaptchaHandler.gClearById(captchaId);
    email = this.params.email;
    if (!email) {
      return this.status = 400;
    }
    message = config.emailOrg + " - 邮箱验证";
    yield* SecurityCodeService.gSendSecurityCodeToEmail(email, message, message);
    return this.status = 204;
  };

}).call(this);
