(function() {
  var Meta, config, fileUtil, gUpload, path;

  path = require('path');

  config = require('../config');

  fileUtil = require('../fileUtil');

  Meta = require('../Meta');

  gUpload = function*(files, query) {
    var entityName, field, fieldMeta, fieldName, file, fileFinalFullPath, fileRelativePath, fileTargetDir, ref, ref1, subDir;
    if (!files) {
      return false;
    }
    file = null;
    for (field in files) {
      file = files[field];
      break;
    }
    if (file == null) {
      return false;
    }
    entityName = query.entityName;
    fieldName = query.fieldName;
    if (!(entityName && fieldName)) {
      return false;
    }
    if (entityName && fieldName) {
      fieldMeta = (ref = Meta.getEntityMeta(entityName)) != null ? (ref1 = ref.fields) != null ? ref1[fieldName] : void 0 : void 0;
    }
    subDir = (fieldMeta != null ? fieldMeta.fileStoreDir : void 0) || "default";
    fileTargetDir = path.join(config.fileDir, subDir);
    fileFinalFullPath = path.join(fileTargetDir, Meta.newObjectId().toString() + path.extname(file.path));
    yield* fileUtil.gMoveFileTo(file.path, fileFinalFullPath);
    fileRelativePath = path.relative(config.fileDir, fileFinalFullPath);
    return {
      fileRelativePath: fileRelativePath,
      fileSize: file.size
    };
  };

  exports.gUpload = function*() {
    var result;
    result = (yield* gUpload(this.request.body.files, this.query));
    if (result) {
      return this.body = result;
    } else {
      return this.status = 400;
    }
  };

  exports.gUpload2 = function*() {
    var result;
    result = (yield* gUpload(this.request.body.files, this.query));
    if (result) {
      result.success = true;
    } else {
      result = {
        success: false
      };
    }
    return this.body = '<textarea data-type="application/json">' + JSON.stringify(result) + '</textarea>';
  };

  exports.gUploadForRichText = function*() {
    var file, files, result;
    files = this.request.body.files;
    if (!files) {
      return this.status = 400;
    }
    file = files.f0;
    if (!file) {
      return this.status = 400;
    }
    result = (yield* exports.gUploadUtil(file, 'RichText'));
    this.type = 'text/html';
    return this.body = config.fileDownloadPrefix + result.fileRelativePath;
  };

  exports.gUploadUtil = function*(file, subDir) {
    var fileFinalFullPath, fileRelativePath, fileSize, fileTargetDir;
    fileTargetDir = path.join(config.fileDir, subDir);
    fileSize = file.size;
    fileFinalFullPath = path.join(fileTargetDir, Meta.newObjectId().toString() + path.extname(file.path));
    yield* fileUtil.gMoveFileTo(file.path, fileFinalFullPath);
    fileRelativePath = path.relative(config.fileDir, fileFinalFullPath);
    return {
      fileRelativePath: fileRelativePath,
      fileSize: fileSize
    };
  };

}).call(this);
