(function() {
  var EntityService, Meta, defaultMenu, gAddDefaultMenu, gCreateAdminUser, log;

  log = require('./log');

  Meta = require('./Meta');

  EntityService = require('./service/EntityService');

  exports.gInit = function*() {
    yield* gCreateAdminUser();
    return (yield* gAddDefaultMenu());
  };

  gCreateAdminUser = function*() {
    var hasAdmin;
    hasAdmin = (yield* EntityService.gFindOneByCriteria(null, 'F_User', {
      admin: true
    }));
    if (hasAdmin) {
      return;
    }
    log.system.info('Create default admin user');
    return (yield* EntityService.gCreate(null, 'F_User', {
      _id: Meta.newObjectId().toString(),
      admin: true,
      username: 'admin',
      password: Meta.hashPassword('admin')
    }));
  };

  gAddDefaultMenu = function*() {
    var hasMenu;
    hasMenu = (yield* EntityService.gFindOneByCriteria(null, 'F_Menu', {}));
    if (hasMenu) {
      return;
    }
    log.system.info('Create default menu');
    return (yield* EntityService.gCreate(null, 'F_Menu', defaultMenu));
  };

  defaultMenu = {
    "_version": 1,
    "menuGroups": [
      {
        "label": null,
        "menuItems": [
          {
            "label": "用户",
            "toEntity": "F_User",
            "callFunc": null
          }, {
            "label": "Meta",
            "toEntity": null,
            "callFunc": "F.toMetaIndex"
          }
        ]
      }
    ]
  };

}).call(this);
