(function() {
  var Promise, config, nodemailer, pSendMail, prepareSender;

  nodemailer = require('nodemailer');

  Promise = require('bluebird');

  config = require('../config');

  exports.gSendEmail = function*(to, subject, content) {
    var mailOptions, pSendMail;
    if (config.mail == null) {
      throw new Error('无发信机制');
    }
    mailOptions = {
      from: config.mail.user,
      to: to,
      subject: subject,
      text: content
    };
    pSendMail = prepareSender();
    return (yield pSendMail(mailOptions));
  };

  pSendMail = null;

  prepareSender = function() {
    var transporter;
    if (pSendMail != null) {
      return pSendMail;
    }
    transporter = nodemailer.createTransport({
      host: config.mail.host,
      port: config.mail.port,
      auth: {
        user: config.mail.user,
        pass: config.mail.password
      }
    });
    pSendMail = Promise.promisify(transporter.sendMail.bind(transporter));
    return pSendMail;
  };

}).call(this);
