(function() {
  var Meta, log;

  Meta = require('../Meta');

  log = require('../log');

  exports.gSyncWithMeta = function*(mongo) {
    var c, currentIndexes, db, e, entities, entityMeta, entityName, f, fc, fields, fieldsArray, i, options, results, tableName;
    db = (yield* mongo.gDatabase());
    entities = Meta.getEntities();
    results = [];
    for (entityName in entities) {
      entityMeta = entities[entityName];
      if (entityMeta.db !== Meta.DB.mongo) {
        continue;
      }
      try {
        tableName = entityMeta.tableName;
        c = db.collection(tableName);
        currentIndexes = entityMeta.mongoIndexes || [];
        results.push((yield* (function*() {
          var j, k, len, len1, results1;
          results1 = [];
          for (j = 0, len = currentIndexes.length; j < len; j++) {
            i = currentIndexes[j];
            fieldsArray = i.fields.split(",");
            fields = {};
            for (k = 0, len1 = fieldsArray.length; k < len1; k++) {
              f = fieldsArray[k];
              fc = f.split(":");
              fields[fc[0]] = parseInt(fc[1], 10);
            }
            options = {
              name: tableName + "_" + i.name
            };
            if (i.unique) {
              options.unique = true;
            }
            if (i.sparse) {
              options.sparse = true;
            }
            results1.push((yield c.createIndex(fields, options)));
          }
          return results1;
        })()));
      } catch (error) {
        e = error;
        results.push(log.system.error(e, 'create mongo index', entityName));
      }
    }
    return results;
  };

}).call(this);
