(function() {
  var Meta, log,
    indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  Meta = require('../Meta');

  log = require('../log');

  exports.gSyncWithMeta = function*(mysql) {
    var currentIndexes, e, entities, entityMeta, entityName, results, tableName;
    entities = Meta.getEntities();
    results = [];
    for (entityName in entities) {
      entityMeta = entities[entityName];
      if (entityMeta.db !== Meta.DB.mysql) {
        continue;
      }
      try {
        tableName = entityMeta.tableName;
        currentIndexes = entityMeta.mysqlIndexes || [];
        results.push((yield* mysql.gWithTransaction(function*(conn) {
          var existedIndexNames, f, fc, fields, fieldsArray, i, indexType, j, k, len, len1, r, ref, results1, sql, unique;
          r = (yield conn.pRead('show index from ' + tableName));
          existedIndexNames = (function() {
            var j, len, results1;
            results1 = [];
            for (j = 0, len = r.length; j < len; j++) {
              i = r[j];
              results1.push(i.Key_name.toLowerCase());
            }
            return results1;
          })();
          results1 = [];
          for (j = 0, len = currentIndexes.length; j < len; j++) {
            i = currentIndexes[j];
            if (ref = i.toLowerCase(), indexOf.call(existedIndexNames, ref) >= 0) {
              continue;
            }
            fieldsArray = i.fields.split(",");
            fields = [];
            for (k = 0, len1 = fieldsArray.length; k < len1; k++) {
              f = fieldsArray[k];
              fc = f.split(":");
              fields.push(mysql.escapeId(fc[0]) + " " + (parseInt(fc[1], 10) > 0 && "ASC" || "DESC"));
            }
            fields = fields.join(", ");
            unique = i.unique && 'UNIQUE' || '';
            indexType = i.indexType && i.indexType || '';
            sql = "create " + unique + " index " + (mysql.escapeId(i.name)) + " " + indexType + " on " + (mysql.escapeId(tableName)) + "(" + fields + ")";
            results1.push((yield conn.pWrite(sql)));
          }
          return results1;
        })));
      } catch (error) {
        e = error;
        results.push(log.system.error(e, entityName));
      }
    }
    return results;
  };

}).call(this);
