(function() {
  var bluebird, co, log, redis, subscriberClient, subscribers;

  redis = require("redis");

  bluebird = require("bluebird");

  co = require('co');

  bluebird.promisifyAll(redis.RedisClient.prototype);

  bluebird.promisifyAll(redis.Multi.prototype);

  log = require('../log');

  subscribers = {};

  subscriberClient = null;

  exports.gInit = function*() {
    var client;
    client = redis.createClient();
    exports.client = client;
    client.on("error", function(err) {
      return log.system.error(err, 'init redis');
    });
    client.on("ready", function() {
      return log.system.info("Redis ready");
    });
    client.on("connect", function() {
      return log.system.info("Redis connect");
    });
    subscriberClient = redis.createClient();
    subscriberClient.on("subscribe", function() {
      return log.system.info("Redis subscribe");
    });
    subscriberClient.on("message", function(channel, message) {
      var h, handlers, i, len, results;
      log.system.info('ON REDIS MESSAGE', channel, message);
      handlers = subscribers[channel];
      if (handlers) {
        results = [];
        for (i = 0, len = handlers.length; i < len; i++) {
          h = handlers[i];
          results.push(co(function*() {
            return (yield* h(message));
          }));
        }
        return results;
      }
    });
    yield subscriberClient.subscribeAsync('test', 'MetaChange');
    return (yield* exports.gPublish('test', 'hello'));
  };

  exports.gDispose = function*() {
    if (exports.client) {
      exports.client.quit();
    }
    if (subscriberClient) {
      yield subscriberClient.unsubscribeAsync('MetaChange');
      return subscriberClient.quit();
    }
  };

  exports.subscribe = function(channel, handler) {
    subscribers[channel] = subscribers[channel] || [];
    return subscribers[channel].push(handler);
  };

  exports.gPublish = function*(channel, message) {
    if (exports.client) {
      return (yield exports.client.publishAsync(channel, message));
    }
  };

}).call(this);
